uniform sampler2D inputImageTexture;
uniform sampler2D toneCurveTexture;
varying highp vec2 textureCoordinate;
uniform lowp float vignetteStart;
uniform lowp float vignetteEnd;
void main()
{
    lowp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 outputColor  = textureColor;
    lowp float           d = distance(textureCoordinate, vec2(0.5,0.5));
    lowp vec3 rgb          = textureColor.rgb;
    d = 1.0 - smoothstep(vignetteStart, vignetteEnd, d);
    rgb *= d;
    outputColor.rgb            = rgb;
    lowp float redCurveValue   = texture2D(toneCurveTexture, vec2(outputColor.r, 0.0)).r;
    lowp float greenCurveValue = texture2D(toneCurveTexture, vec2(outputColor.g, 0.0)).g;
    lowp float blueCurveValue  = texture2D(toneCurveTexture, vec2(outputColor.b, 0.0)).b;
    outputColor                = vec4(redCurveValue, greenCurveValue, blueCurveValue,outputColor.a);
    gl_FragColor               = outputColor;
//    gl_FragColor = texture2D(toneCurveTexture,  textureCoordinate);
}